function plotcorr
f1=1.57542E9;
f2=1.22760E9;
C=299792458;
C1=f1^2/(f1^2-f2^2);
C2=f2^2/(f1^2-f2^2);

v=textread('corr.txt');
t=v(:,1)-v(1,1);
%c1=v(:,2:2:end);
%c2=v(:,3:2:end);
c1=v(:,2:end);
c2=v(:,2:end);

dc1=C/f1*(c1-interp1(t(1:30:end),c1(1:30:end,:),t));
dc2=C/f2*(c2-interp1(t(1:30:end),c2(1:30:end,:),t));
%dc1(dc1==0.0)=nan;
%dc2(dc2==0.0)=nan;

dcf=dc1-dc2;
dci=C1*dc1-C2*dc2;
%dcf(abs(dcf)>0.05)=nan;
dc=dc1;
dc(dc==0.0|abs(dc)>0.05)=nan;

i=find(~isnan(dc));
disp(sprintf('rms=%.4f',sqrt(mean(mean(dc(i).^2)))))

figure, hold on, grid on, box on
plot(t/3600,dc,'-')
xlim([0,6]), ylim([-0.2,0.2])
moveax

