//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "main.h"
#include "convdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TConvDialog *ConvDialog;

//---------------------------------------------------------------------------
extern "C" {
extern void pos2kml(const char *infile, const char *outfile, gtime_t ts,
                    gtime_t te, double *offset, int tcolor, int pcolor,
                    int posf, int degf, int outalt, int outtime, double tint,
                    int qflg, const char *sep);
}
//---------------------------------------------------------------------------
__fastcall TConvDialog::TConvDialog(TComponent* Owner)
	: TForm(Owner)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::StartTimeClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::AddOffsetClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::BtnGoogleClick(TObject *Sender)
{
	STARTUPINFO si={0};
	PROCESS_INFORMATION info;
	char cmd[256],file[256],*p;
	if (MainForm->OutputFile->Text=="") return;
	strcpy(file,MainForm->OutputFile->Text.c_str());
	if ((p=strrchr(file,'.'))) strcpy(p,".kml");
	sprintf(cmd,"\"%s\" \"%s\"",MainForm->GoogleEarthFile,file);
	si.cb=sizeof(si);
	if (!CreateProcess(NULL,cmd,NULL,NULL,false,CREATE_NO_WINDOW,NULL,NULL,&si,
					   &info)) return;
	CloseHandle(info.hProcess);
	CloseHandle(info.hThread);
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::BtnConvertClick(TObject *Sender)
{
	char infile[256],sep[64]=" ";
	double offset[3]={0},es[6]={2000,1,1},ee[6]={2000,1,1};
	gtime_t ts={0},te={0};
	if (MainForm->OutputFile->Text=="") return;
	strcpy(infile,MainForm->OutputFile->Text.c_str());
	if (MainForm->FieldSep!="") strcpy(sep,MainForm->FieldSep.c_str());
	if (StartTime->Checked) {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",es  ,es+1,es+2);
		sscanf(TimeH1->Text.c_str(),"%lf:%lf:%lf",es+3,es+4,es+5);
		sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",ee  ,ee+1,ee+2);
		sscanf(TimeH2->Text.c_str(),"%lf:%lf:%lf",ee+3,ee+4,ee+5);
		ts=epoch2time(es);
		te=epoch2time(ee);
	}
	if (AddOffset->Checked) {
		offset[0]=Offset1->Text.ToDouble();
		offset[1]=Offset2->Text.ToDouble();
		offset[2]=Offset3->Text.ToDouble();
	}
	pos2kml(infile,"",ts,te,offset,TrackColor->ItemIndex,PointColor->ItemIndex,
	        MainForm->SolFormat,MainForm->LatLonFormat,
	        OutputAlt->ItemIndex,OutputTime->ItemIndex,
	        TimeInt->Text.ToDouble(),QFlags->ItemIndex,sep);
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::BtnCloseClick(TObject *Sender)
{
	Close();	
}
//---------------------------------------------------------------------------
void __fastcall TConvDialog::UpdateEnable(void)
{
	Offset1->Enabled=AddOffset->Checked;
	Offset2->Enabled=AddOffset->Checked;
	Offset3->Enabled=AddOffset->Checked;
	TimeY1->Enabled=StartTime->Checked;
	TimeH1->Enabled=StartTime->Checked;
	TimeY2->Enabled=StartTime->Checked;
	TimeH2->Enabled=StartTime->Checked;
}
//---------------------------------------------------------------------------

