//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "viewer.h"
#include "setdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSetDialog *SetDialog;
//---------------------------------------------------------------------------
__fastcall TSetDialog::TSetDialog(TComponent* Owner)
	: TForm(Owner)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::FormShow(TObject *Sender)
{
	AnsiString s;
	PosMode      ->ItemIndex=MainForm->PosMode;
	Freq         ->ItemIndex=MainForm->Freq;
	Solution     ->ItemIndex=MainForm->Solution;
	ElMask       ->Text     =s.sprintf("%.0f",MainForm->ElMask);
	Datum        ->ItemIndex=MainForm->Datum;
	DynamicModel ->ItemIndex=MainForm->DynamicModel;
	IonoEst      ->ItemIndex=MainForm->IonoEst;
	TropEst      ->ItemIndex=MainForm->TropEst;
	AmbRes       ->ItemIndex=MainForm->AmbRes;
	ValidThresAR ->Text=s.sprintf("%.1f",MainForm->ValidThresAR);
	OutCntResetBias->Text=s.sprintf("%d",MainForm->OutCntResetBias);
	LockCntFixAmb  ->Text=s.sprintf("%d",MainForm->LockCntFixAmb);
	MaxAgeDiff   ->Text=s.sprintf("%.1f",MainForm->MaxAgeDiff);
	RejectThres  ->Text=s.sprintf("%.1f",MainForm->RejectThres);
	SolFormat    ->ItemIndex=MainForm->SolFormat;
	TimeFormat   ->ItemIndex=MainForm->TimeFormat;
	LatLonFormat ->ItemIndex=MainForm->LatLonFormat;
	FieldSep     ->Text=MainForm->FieldSep;
	MeasErr1     ->Text=s.sprintf("%.1f",MainForm->MeasErr1);
	MeasErr2     ->Text=s.sprintf("%.3f",MainForm->MeasErr2);
	MeasErr3     ->Text=s.sprintf("%.3f",MainForm->MeasErr3);
	MeasErr4     ->Text=s.sprintf("%.3f",MainForm->MeasErr4);
	SatClkStab   ->Text=s.sprintf("%.2E",MainForm->SatClkStab);
	PrNoise1     ->Text=s.sprintf("%.2E",MainForm->PrNoise1);
	PrNoise2     ->Text=s.sprintf("%.2E",MainForm->PrNoise2);
	PrNoise3     ->Text=s.sprintf("%.2E",MainForm->PrNoise3);
	AntPcvCorr   ->Checked=(bool)MainForm->AntPcvCorr;
	RovAnt       ->Text=MainForm->RovAnt;
	RefAnt       ->Text=MainForm->RefAnt;
	RovAntE      ->Text=s.sprintf("%.3f",MainForm->RovAntE);
	RovAntN      ->Text=s.sprintf("%.3f",MainForm->RovAntN);
	RovAntU      ->Text=s.sprintf("%.3f",MainForm->RovAntU);
	RefAntE      ->Text=s.sprintf("%.3f",MainForm->RefAntE);
	RefAntN      ->Text=s.sprintf("%.3f",MainForm->RefAntN);
	RefAntU      ->Text=s.sprintf("%.3f",MainForm->RefAntU);
	AntPcvFile   ->Text=MainForm->AntPcvFile;
	IntpRefObs   ->Checked=MainForm->IntpRefObs;
	NetRSCorr    ->Checked=MainForm->NetRSCorr;
	NetRSCorrFile->Text=MainForm->NetRSCorrFile;
	SatClkCorr   ->Checked=MainForm->SatClkCorr;
	SatClkCorrFile->Text=MainForm->SatClkCorrFile;
	GoogleEarthFile->Text=MainForm->GoogleEarthFile;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnOkClick(TObject *Sender)
{
	MainForm->PosMode     =PosMode     ->ItemIndex;
	MainForm->Freq        =Freq        ->ItemIndex;
	MainForm->Solution    =Solution    ->ItemIndex;
	MainForm->ElMask      =ElMask      ->Text.ToDouble();
	MainForm->Datum       =Datum       ->ItemIndex;
	MainForm->DynamicModel=DynamicModel->ItemIndex;
	MainForm->IonoEst     =IonoEst     ->ItemIndex;
	MainForm->TropEst     =TropEst     ->ItemIndex;
	MainForm->AmbRes      =AmbRes      ->ItemIndex;
	MainForm->ValidThresAR=ValidThresAR->Text.ToDouble();
	MainForm->OutCntResetBias=OutCntResetBias->Text.ToInt();
	MainForm->LockCntFixAmb  =LockCntFixAmb  ->Text.ToInt();
	MainForm->MaxAgeDiff  =MaxAgeDiff ->Text.ToDouble();
	MainForm->RejectThres =RejectThres->Text.ToDouble();
	MainForm->SolFormat   =SolFormat  ->ItemIndex;
	MainForm->TimeFormat  =TimeFormat ->ItemIndex;
	MainForm->LatLonFormat=LatLonFormat->ItemIndex;
	MainForm->FieldSep    =FieldSep   ->Text;
	MainForm->MeasErr1    =MeasErr1   ->Text.ToDouble();
	MainForm->MeasErr2    =MeasErr2   ->Text.ToDouble();
	MainForm->MeasErr3    =MeasErr3   ->Text.ToDouble();
	MainForm->MeasErr4    =MeasErr4   ->Text.ToDouble();
	MainForm->SatClkStab  =SatClkStab ->Text.ToDouble();
	MainForm->PrNoise1    =PrNoise1   ->Text.ToDouble();
	MainForm->PrNoise2    =PrNoise2   ->Text.ToDouble();
	MainForm->PrNoise3    =PrNoise3   ->Text.ToDouble();
	MainForm->AntPcvCorr  =(int)AntPcvCorr->Checked;
	MainForm->RovAnt      =RovAnt->Text;
	MainForm->RefAnt      =RefAnt->Text;
	MainForm->RovAntE     =RovAntE->Text.ToDouble();
	MainForm->RovAntN     =RovAntN->Text.ToDouble();
	MainForm->RovAntU     =RovAntU->Text.ToDouble();
	MainForm->RefAntE     =RefAntE->Text.ToDouble();
	MainForm->RefAntN     =RefAntN->Text.ToDouble();
	MainForm->RefAntU     =RefAntU->Text.ToDouble();
	MainForm->IntpRefObs  =IntpRefObs->Checked;
	MainForm->NetRSCorr   =NetRSCorr->Checked;
	MainForm->NetRSCorrFile=NetRSCorrFile->Text;
	MainForm->SatClkCorr  =SatClkCorr->Checked;
	MainForm->SatClkCorrFile=SatClkCorrFile->Text;
	MainForm->AntPcvFile  =AntPcvFile->Text;
	MainForm->GoogleEarthFile=GoogleEarthFile->Text;
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::SolFormatChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::PosModeChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::AmbResChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::AntPcvCorrClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::NetRSCorrClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::SatClkCorrClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::UpdateEnable(void)
{
	TEdit *e[]={
		RovAnt,RovAntE,RovAntN,RovAntU,RefAnt,RefAntE,RefAntN,RefAntU,AntPcvFile
	};
	Freq->Enabled=PosMode->ItemIndex>=1;
	Solution->Enabled=PosMode->ItemIndex>=1&&PosMode->ItemIndex<=2;
	MaxAgeDiff->Enabled=PosMode->ItemIndex>=1;
	RejectThres->Enabled=PosMode->ItemIndex>=1;
	DynamicModel->Enabled=PosMode->ItemIndex>=1&&PosMode->ItemIndex<=2;
	IonoEst->Enabled=PosMode->ItemIndex>=1&&Freq->ItemIndex>=1;
	TropEst->Enabled=PosMode->ItemIndex>=1;
	GroupRovAnt->Enabled=AntPcvCorr->Checked;
	GroupRefAnt->Enabled=AntPcvCorr->Checked;
	for (int i=0;i<9;i++) e[i]->Enabled=AntPcvCorr->Checked;
	BtnAntPcvFile->Enabled=AntPcvCorr->Checked;
	BtnAntPcvView->Enabled=AntPcvCorr->Checked;
	AmbRes->Enabled=PosMode->ItemIndex>=2;
	ValidThresAR->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	LockCntFixAmb->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	OutCntResetBias->Enabled=PosMode->ItemIndex>=2;
	NetRSCorrFile->Enabled=NetRSCorr->Checked;
	BtnNetRSCorrView->Enabled=NetRSCorr->Checked;
	BtnNetRSCorrFile->Enabled=NetRSCorr->Checked;
	SatClkCorrFile->Enabled=SatClkCorr->Checked;
	BtnSatClkCorrView->Enabled=SatClkCorr->Checked;
	BtnSatClkCorrFile->Enabled=SatClkCorr->Checked;
	TimeFormat->Enabled=SolFormat->ItemIndex!=2;
	LatLonFormat->Enabled=SolFormat->ItemIndex==0;
	FieldSep->Enabled=SolFormat->ItemIndex!=2;
	LabelTimeFormat->Enabled=SolFormat->ItemIndex!=2;
	LabelLatLonFormat->Enabled=SolFormat->ItemIndex==0;
	LabelFieldSep->Enabled=SolFormat->ItemIndex!=2;
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnAntPcvViewClick(TObject *Sender)
{
	if (AntPcvFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(AntPcvFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnAntPcvFileClick(TObject *Sender)
{
	OpenDialog->FileName=AntPcvFile->Text;
	OpenDialog->FilterIndex=3;
	if (!OpenDialog->Execute()) return;
	AntPcvFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnNetRSCorrViewClick(TObject *Sender)
{
	if (NetRSCorrFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(NetRSCorrFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnSatClkCorrViewClick(TObject *Sender)
{
	if (SatClkCorrFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(SatClkCorrFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnNetRSCorrFileClick(TObject *Sender)
{
	OpenDialog->FileName=NetRSCorrFile->Text;
	OpenDialog->FilterIndex=4;
	if (!OpenDialog->Execute()) return;
	NetRSCorrFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnSatClkCorrFileClick(TObject *Sender)
{
	OpenDialog->FileName=SatClkCorrFile->Text;
	OpenDialog->FilterIndex=4;
	if (!OpenDialog->Execute()) return;
	SatClkCorrFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TSetDialog::BtnGoogleEarthFileClick(TObject *Sender)
{
	OpenDialog->FileName=GoogleEarthFile->Text;
	OpenDialog->FilterIndex=2;
	if (!OpenDialog->Execute()) return;
	GoogleEarthFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
